
proc create-master {num_resp inqTO Xpos Ypos } {

    global BTmaster Sim
    set BTmaster [new BTNode 0 0 1 Xpos Ypos]
    
    $BTmaster set-target $Sim(repl)
    $Sim(repl) install 0 [$BTmaster set lm_]
    
    set bthost [$BTmaster set bthost_]
    $bthost set numResponses_ $num_resp
    $bthost set inqTimeout_ $inqTO

    if {$Sim(Trace) == "on"}  {
	$BTmaster color "red"
	$BTmaster shape "circle"
	$BTmaster dump-namconfig
    }
}

proc setup-FPQ { } {
 
    global BTmaster Sim
    set sched [$BTmaster set sched_]
    $sched cmd QOS_init  [expr $Sim(NumDevices)-1]   $Sim(FPQ_Time_begin) $Sim(FPQ_alpha) 

    for {set i 1} {$i < $Sim(NumDevices) } {incr i} {
	$sched cmd QOS_FR_s  $i [lindex $Sim(FR_slave)  [expr $i - 1] ]
	$sched cmd QOS_FR_m  $i [lindex $Sim(FR_master) [expr $i - 1] ]
	$sched cmd QOS_MD_s  $i [lindex $Sim(MD_slave)  [expr $i - 1] ]
	$sched cmd QOS_MD_m  $i [lindex $Sim(MD_master) [expr $i - 1] ]
    }
}


proc create-slave {index inqSO Xpos Ypos} {
    global BTslave Sim
    set BTslave($index) [new BTNode $index $index 0 Xpos Ypos]
    
    $BTslave($index) setISoffset $inqSO
    $BTslave($index) set-target $Sim(repl)
    
    $Sim(repl) install $index [$BTslave($index) set lm_]
    if {$Sim(Trace) == "on"} {
	$BTslave($index) color "red"
	$BTslave($index) shape "circle"
	$BTslave($index) dump-namconfig
    }
}


proc config-app-master-slave {i Transport App IdleT} {
	global Sim ns BTmaster BTslave

	set Sim(trans_master:$i) [new Agent/$Transport]
	set Sim(appl_master:$i) [new Application/$App]
	set Sim(temp_master:$i) [string range $Transport 0 2]
	if {$Sim(temp_master:$i) == "TCP"} {
	    set Sim(sink_master:$i) [new Agent/TCPSink]
	} else {
	    set Sim(sink_master:$i) [new Agent/Null]

	    $Sim(appl_master:$i) set interpackets_  [expr $IdleT]ms
	    $Sim(trans_master:$i) set packetSize_ 1600
	}

	$ns attach-agent $BTmaster $Sim(trans_master:$i)
	$ns attach-agent $BTslave($i) $Sim(sink_master:$i)
	$ns connect $Sim(trans_master:$i) $Sim(sink_master:$i)
	$BTmaster attach-app [expr $i-1] $Sim(appl_master:$i)
	$Sim(appl_master:$i) attach-agent $Sim(trans_master:$i)
}


proc config-app-slave-master {i Transport App IdleT} {
	global Sim ns BTmaster BTslave

	set Sim(trans_slave:$i) [new Agent/$Transport]
	set Sim(appl_slave:$i) [new Application/$App]
	set Sim(temp_slave:$i) [string range $Transport 0 2]
	if {$Sim(temp_slave:$i) == "TCP"} {
	    set Sim(sink_slave:$i) [new Agent/TCPSink]
	} else {
	    set Sim(sink_slave:$i) [new Agent/Null]

	    $Sim(appl_slave:$i) set interpackets_  [expr $IdleT]ms
	    $Sim(trans_slave:$i) set packetSize_ 1600
	}

	$ns attach-agent $BTslave($i) $Sim(trans_slave:$i)
	$ns attach-agent $BTmaster $Sim(sink_slave:$i)
	$ns connect $Sim(trans_slave:$i) $Sim(sink_slave:$i)
	$BTslave($i) attach-app 0 $Sim(appl_slave:$i)
	$Sim(appl_slave:$i) attach-agent $Sim(trans_slave:$i)

}


proc config-trace {} {
    global ns Sim BTmaster BTslave
    set nam_fp $Sim(namFP)
    set tr $Sim(trFP)

    $ns trace-all $tr

    set Sim(trace:0) [$ns create-trace Deque $tr $BTmaster $BTmaster]
    $Sim(trace:0) namattach $nam_fp
    $Sim(repl) install 0 $Sim(trace:0)
    $Sim(trace:0) target [$BTmaster set lm_]
		
    set dropT(0) [$ns create-trace Drop $tr $BTmaster $BTmaster]
    $dropT(0) namattach $nam_fp
    $BTmaster set-droptarget $dropT(0)

    set nodetrace(0) [new Trace/BTNodeColor 0]
    $nodetrace(0) namattach $nam_fp
    $BTmaster set-target $nodetrace(0)
    $nodetrace(0) target $Sim(repl)
    $nodetrace(0) set src_ 0


	for {set i 1} {$i < $Sim(NumDevices)} {incr i} {
	    
	    if {$Sim(AgentTrace) == "on"} {
		if {$Sim(temp_master:$i) == "TCP"} {
		    $ns add-agent-trace $Sim(trans_master:$i) tcp$i
		    $ns monitor-agent-trace $Sim(trans_master:$i)
		}
		if {$Sim(temp_slave:$i) == "TCP"} {
		    $ns add-agent-trace $Sim(trans_slave:$i) tcp$i
		    $ns monitor-agent-trace $Sim(trans_slave:$i)
		}
	    }

	    set Sim(trace:$i) [$ns create-trace Deque $tr $BTmaster $BTslave($i)]
	    $Sim(trace:$i) namattach $nam_fp
	    $Sim(repl) install $i $Sim(trace:$i)
	    $Sim(trace:$i) target [$BTslave($i) set lm_]
		
	    set dropT($i) [$ns create-trace Drop $tr $BTmaster $BTslave($i)]
	    $dropT($i) namattach $nam_fp
	    $BTslave($i) set-droptarget $dropT($i)

	    set nodetrace($i) [new Trace/BTNodeColor 0]
	    $nodetrace($i) namattach $nam_fp
	    $BTslave($i) set-target $nodetrace($i)
	    $nodetrace($i) target $Sim(repl)
	    $nodetrace($i) set src_ $i
	}
}


proc finish {} {
	global Sim
	exit 0
}


proc start_appli { } {
    global ns Sim BTmaster BTslave

    for {set i 1} {$i < $Sim(NumDevices)} {incr i} {
	set t [lindex $Sim(LStartAppli_master) [expr $i-1] ]
	if { $t != 0 } {
	    $ns at $t "$Sim(appl_master:$i) start"
	}

	set t [lindex $Sim(LStartAppli_slave) [expr $i-1] ]
	if { $t != 0 } {
	    $ns at $t "$Sim(appl_slave:$i) start"
	}
    }    
}








