
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  {date here}, International Business Machines Corporation and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/
/* Simulates a scheduling scheme which is a slight variation 
   of Deficit Round Robin (DRR) Ref: 
   Please refer to the Bluehoc document for details
*/



#include <math.h>
#include "bt-core.h"

static class BT_DRRClass : public TclClass 
{
public:
	BT_DRRClass() : TclClass("BT_DRR"){}
	TclObject* create( int, const char*const*) {
	 	return (new BT_DRRScheduler);
	}
} class_drr;

BT_DRRScheduler::BT_DRRScheduler() : ph_(this), currQueue_(0), numFlows_(0), slotsPerCycle_(0), nextround_(1)
{
	bind("cycleTime_", &cycleTime_);

	for (int i=0; i < MaxQueues; i++) {
		rate_[i] = 0;
		tos_[i] = 0;
		dc_[i] = 3000;
		incr_[i] = 0;
		backlog_fwd_[i] = 0;
		backlog_rev_[i] = 0;
		active_[i] = 0;
		quanta_[i] = 1000;		
		maxPollInterval_[i] = 40;
	}
	
	pollEvent_ = new (PollEvent*)[MaxQueues];
	pollQ_ = new PacketQueue();
	lc_ = new (NsObject*)[MaxQueues];
	FPQ = new (struct QoSsupport);
}

int BT_DRRScheduler::command(int argc, const char*const* argv)
{
	Tcl& tcl = Tcl::instance();
	if (argc == 4) {
	        //
	        // $sched install $slot $lc
		//
		// Pointers to LinkController objects
		if (strcmp(argv[1], "install") == 0) {
			int slot = atoi(argv[2]);
			lc_[slot] = (NsObject*)TclObject::lookup(argv[3]);
			return (TCL_OK);
		}

		//
		// $sched QOS_FR_s $IPslave $FR
		//
		// Pointers to LinkController objects
		if (strcmp(argv[1], "QOS_FR_s") == 0) {
			int IPslave = atoi(argv[2]);
			float FR = (float) ( atof(argv[3]) ); 
			
			if ( (IPslave > 0) && (IPslave < 8) ) {
			  FPQ->FR_s[IPslave-1] = FR;
			  return (TCL_OK);
			}
			else {
			  return (TCL_ERROR);
			}
		}
		//
		// $sched QOS_FR_m $IPslave $FR
		//
		// Pointers to LinkController objects
		if (strcmp(argv[1], "QOS_FR_m") == 0) {
			int IPslave = atoi(argv[2]);
			float FR = (float) ( atof(argv[3]) ); 
			
			if ( (IPslave > 0) && (IPslave < 8) ) {
			  FPQ->FR_m[IPslave-1] = FR;
			  return (TCL_OK);
			}
			else {
			  return (TCL_ERROR);
			}
		}

		//
		// $sched QOS_MD_s $IPslave $MD
		//
		// Pointers to LinkController objects
		if (strcmp(argv[1], "QOS_MD_s") == 0) {
			int IPslave = atoi(argv[2]);
			int MD =  atoi(argv[3]) ; 
			
			if ( (IPslave > 0) && (IPslave < 8) ) {
			  FPQ->MD_s[IPslave - 1] = MD;
			  return (TCL_OK);
			}
			else {
			  return (TCL_ERROR);
			}
		}

		//
		// $sched QOS_MD_m $IPslave $MD
		//
		// Pointers to LinkController objects
		if (strcmp(argv[1], "QOS_MD_m") == 0) {
			int IPslave = atoi(argv[2]);
			int MD = atoi(argv[3]) ; 
			
			if ( (IPslave > 0) && (IPslave < 8) ) {
			  FPQ->MD_m[IPslave - 1] = MD;
			  return (TCL_OK);
			}
			else {
			  return (TCL_ERROR);
			}
		}

	}
	if (argc == 5) {
		/*
		 * $sched QOS_init $nb_slave $time_begin $alpha
		 */
		if (strcmp(argv[1], "QOS_init") == 0) {
		        char nb_slav_ = (char) (atoi(argv[2]) );
			int Time_begi_ = atoi(argv[3]);	     
		       	double alph_ = atof(argv[4] );	
			
			QOS_init( nb_slav_ , Time_begi_ , alph_);			
		       	return (TCL_OK);
		}
	}
	
	return (BiConnector::command(argc, argv));
}

uchar
BT_DRRScheduler::mapQoS (uchar ch, flowSpec* qos, con_attr* qoslm_)
{
	bt_packet_type type;
	int mtu = qos->mtu;
	double rate = qos->token_rate*1000;
	
	// If application is loss sensitive, use FEC
	if (qos->loss_sensitivity) {
		// select appropriate packet type based on MTU
		if ((mtu > Payload[14]) || ((mtu <= Payload[14]) && (mtu > Payload[10])))
			type = BT_DM5;
		else if (mtu <= Payload[10] && mtu > Payload[3])
			type = BT_DM3;
		else 
			type = BT_DM1;
	}
	else {
		// select appropriate packet type based on MTU
		if ((mtu > Payload[15]) || ((mtu <= Payload[15]) && (mtu > Payload[11])))
			type = BT_DH5;
		else if (mtu <= Payload[11] && mtu > Payload[4])
			type = BT_DH3;
		else 
			type = BT_DH1;
	}	
	int pi = (int)(Payload[type]*8/(rate*SlotTime));
	uchar result = updateQuanta(ch, qos->token_rate, type);
	if (result) {
		qoslm_->packet_type = type;
		qoslm_->polling_interval = pi;  	// To be used when QoS is reserved
		                                        // in the reverse direcetion as well
	}
	return result;
}

/* Does admission control based on slot 
availability within cycle time. Admission
control can be improved upon
*/

uchar
BT_DRRScheduler::updateQuanta (uchar ch, int token_rate, bt_packet_type type)
{
	double slots;
	int quanta; 

	if (token_rate == -1) {
		slots = 0.5*(cycleTime_/SlotTime - slotsPerCycle_);
		quanta_[ch] = (int)(slots*Payload[type]*8)/(1+SlotSize[type]);
		slotsPerCycle_ += slots;
		numFlows_ ++; 
		active_[ch] = 1;
		return 1;
	}
	if (token_rate == 0) 
		quanta = (int)(cycleTime_*DefaultRate);
	else {
		quanta = (int)(cycleTime_*token_rate*1000);
	}
	slots = (1+SlotSize[type])*(quanta/(Payload[type]*8));
	if ((slots+slotsPerCycle_)*SlotTime < cycleTime_) {
		slotsPerCycle_ += slots;
		numFlows_ ++; 
		active_[ch] = 1;
		quanta_[ch] = quanta;
		return 1;
	}
	else 
		return 0;
}	

/* Return the next packet to be scheduled */

Packet* 
BT_DRRScheduler::schedule_next()
{
  Scheduler& s = Scheduler::instance();
  
  double now = s.clock() ;
  double limit = (FPQ->Time_begin );

  if (now < limit ) {
    return DRR_schedule_next();
     }
  else {
      return FPQ_schedule_next();
  }
}




// Return the next packet to be scheduled with QOS polling scheme 
Packet* 
BT_DRRScheduler::FPQ_schedule_next()
{
  Scheduler& s = Scheduler::instance();
  LinkController* lc;
  double now = s.clock();

  int selected = 0; int i , j;
  double sum_Pdata = 0;
  int sum_N=0;
    

  // ############## Computation of Pdata  #######################
  // ############################################################
  for (i = 0; i < FPQ->nb_slave ; ++i) {
    
    if ( (FPQ->begin_packet_s[i] == 0) ) {  
      // one packet has begun to be transmitted      
      FPQ->Pdata_s[i] = 1; }  
    else { 
      double P_int = exp( (FPQ->T_n[i] - now) * 1000 / FPQ->FR_s[i] ) ;

      FPQ->Pdata_s[i] = -P_int * FPQ->P_eq_one_n[i] / FPQ->P_geq_one_n[i] + 1;
    }

    if (FPQ->begin_packet_m[i] == 0) {
      // one packet has begun to be transmitted
      FPQ->Pdata_m[i] = 1;}
    else {
      // We look at the state of the queue of Baseband packets...
      lc = (LinkController* )lc_[i];
      if (lc->curr_reg_) {
	// This is the first d=segment of a L2CAP packet
	FPQ->Pdata_m[i] = 0.5; }
      else {
	// The queue is empty
	FPQ->Pdata_m[i] = 0.0;
        FPQ->Nm[i] = 0;
	FPQ->ITQE[i] = 0;
      }
    }
    
    if  ( (FPQ->MD_s[i] != 0) && (FPQ->ITLN[i] > FPQ->MD_s[i]) ) {
      // Effect of the MDs request on Pdata_s
      FPQ->Pdata_s[i] += 1; }
    if  ( (FPQ->MD_m[i] != 0) && (FPQ->ITQE[i] > FPQ->MD_m[i]) ) {
      // Effect of the MDs request on Pdata_s
      FPQ->Pdata_m[i] += 1; }


    FPQ->Pdata[i] = FPQ->Pdata_s[i] + FPQ->Pdata_m[i];
  }

   
  // ################# Computation of the Priority of each slave ##############
  // ####### and selection of the slave with the highest priority #############
  // ##########################################################################
  for (j = 0 ; j < FPQ->nb_slave ; ++j) {
    sum_Pdata += FPQ->Pdata[j] ;
    sum_N = sum_N + FPQ->N_sm[j] ;
  }
  for (i = 0; i < FPQ->nb_slave ; ++i) {
    FPQ->Pr[i] = FPQ->alpha * (FPQ->Pdata[i] / sum_Pdata) + (1 - FPQ->alpha) * (FPQ->N_sm[i] / sum_N ); 
  }
    
  double value = FPQ->Pr[0];
  
  for (i = 1; i < FPQ->nb_slave ; ++i) {
    if ( value < FPQ->Pr[i] ) {
      selected = i;
      value = FPQ->Pr[i]; }
  }

  // ########################### Update of Parameters ##########################
  // ###########################################################################

  lc = (LinkController*) lc_[selected];
  Packet* pa = lc->send();

  int size = 0;  int nb_slot = 0;

  if (pa) { // The queue is not empty
    hdr_cmn* ch = HDR_CMN(pa);
    hdr_bt* bt = HDR_BT(pa);

    if ( (bt->type == BT_DM5) ||  (bt->type == BT_DH5) ) { // Five-slot packet with data
      nb_slot = 5;    }
    if ( (bt->type == BT_DM3) ||  (bt->type == BT_DH3) ) { // Three-slot packet with data
      nb_slot = 3;    }
    if ( (bt->type == BT_DM1) ||  (bt->type == BT_DH1) ) { // One-slot packet with data
      nb_slot = 1;    }
   
    size = Payload[bt->type];    
    if (nb_slot == 0 ) { nb_slot = 1; }  // for POLL packets (corresponds to an ACK of the previous packet sent by the slave...

    if (FPQ->begin_packet_m[selected] == 1) {
      FPQ->Nm[selected] = 0;     }

    for (i = 0; i < FPQ->nb_slave ; ++i) {
      FPQ->Ns[i] += nb_slot;
      FPQ->Nm[i] += nb_slot;
      FPQ->ITLN[i] += nb_slot;
      FPQ->ITQE[i] += nb_slot;
    }

    if ( Payload[bt->type] == ch->size()  ) {
      FPQ->begin_packet_m[selected] = 0; }
    else {
      FPQ->begin_packet_m[selected] = 1; }

    return pa;
  }
  else { // The queue is empty
    pa = createPOLLpacket(selected + 1);
    hdr_cmn* ch = HDR_CMN(pa);
    hdr_bt* bt = HDR_BT(pa);   
    
    FPQ->Nm[selected] = 0;

    for (i = 0; i < FPQ->nb_slave ; ++i) {
      ++FPQ->Ns[i] ;
      ++FPQ->Nm[i] ;
      ++FPQ->ITLN[i] ;
      ++FPQ->ITQE[i] ;
    }

    FPQ->begin_packet_m[selected] = 1; 
    // Since all transmissions of L2CAP packets are completed...
   
    return pa;
  }
}


// Return the next packet to be scheduled with DRR polling scheme 
// The same as in Bluehoc implementation
Packet* 
BT_DRRScheduler::DRR_schedule_next()
{
	Scheduler& s = Scheduler::instance();
	Packet* p_sched = 0;
	int queue_no = -1;

	
	for (int i = currQueue_; i < currQueue_ + MaxQueues; i++) { 
		int j = i%MaxQueues;
		// if a round is over indicate that DC can be increased now
		if ((j == 0)&& nextround_) {
			nextround_ = 0;
			for (int i=0; i< MaxQueues; i++) 
				incr_[i] = 0;
		}
		LinkController* lc = (LinkController*)lc_[j];

		// see if the the current register at the link controller 
		//corresponding the the current queue has any data to send 
		
		int size = lc->pktSize();

		// mark the queue backlogged in the forward direction if 
		//the queue it has a non-zero packet size 
		backlog_fwd_[j] = size ? 1 : 0;
		size <<= 3;

		// Find if the flow (forward + reverse) is backlogged //
		uchar	backlogged = (backlog_fwd_[j] || backlog_rev_[j]);

		//printf("\nNum : %d\tb_fwd : %d\tb_rev : %d\tdc : %d\tquanta : %d\n", j, backlog_fwd_[j], backlog_rev_[j], dc_[j],  quanta_[j]);

		if (backlogged) {
		// If the DC hasn't already been incremented this
		//round, increment it 
			if (incr_[j] == 0) {
				dc_[j] = MIN(MaxQuanta,dc_[j]+quanta_[j]);
				incr_[j] = 1;
			}
			// If the packetsize to be transmitted in less than 
			//DC get the packet from the current register of the 
			//link controller 
			if (size < dc_[j]) {
				currQueue_ = queue_no = j;
				p_sched = lc->send();
				break;
			}
		} else 
		  dc_[j] = 0;
		
		nextround_ = 1;
	}
	
	//nextround_ = 1;
	if (p_sched) {
		hdr_bt* bt = HDR_BT(p_sched);
		dc_[queue_no] -= (Payload[bt->type])<<3;			
	}
	else {
		if (queue_no < 0) {
		// if the round resulted in no packet being scheduled
		//find the next active queue 
			if (numFlows_) queue_no = DRR_nextActive();
			else return 0;
		}
		// create a poll packet for the next queue with am_addr_ = queue_no+1 
		p_sched = createPOLLpacket(queue_no+1);
	}
      	return p_sched;
}


// Find the next active queue
uchar
BT_DRRScheduler::DRR_nextActive()
{
  
	for (int i=0; i<MaxQueues; i++) {
		currQueue_ = (currQueue_+1)%MaxQueues;
		if (active_[currQueue_])
			break;
	}
	return currQueue_;
}


// handle a packet going up the stack
void 
BT_DRRScheduler::sendUp (Packet* p, Handler* h)
{
        Scheduler& s = Scheduler::instance();
	double now = s.clock() ;
	double limit = FPQ->Time_begin ;
	
	if (now < limit ) {
	  DRR_sendUp( p, this) ;
	}
	else {
	  FPQ_sendUp( p, this); 
	}
}


// handle a packet going up the stack
void 
BT_DRRScheduler::DRR_sendUp (Packet* p, Handler* h)
{
        Scheduler& s = Scheduler::instance();
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt* bt = HDR_BT(p);
	
	int size = Payload[bt->type];
	int index = bt->am_addr -1;	
	int nb_slot;

        // if packetsize is non-zero, mark flow as non backlogged in the reverse direction 
	backlog_rev_[index] = (size) ? 1 : 0;

	if ( (bt->type == BT_NULL) || (bt->type == BT_POLL) || (bt->type == BT_FHS) || (bt->type == BT_ID) ) { // One-slot packet without data
	  nb_slot = 0; //Because of no data
      	}
	else { // Packet with data !!!!
	  if ( (bt->type == BT_DM1) ||  (bt->type == BT_DH1) ) { // One-slot packet with data
	    nb_slot = 1; //Because of 1-slot data
	  }
	  if ( (bt->type == BT_DM3) ||  (bt->type == BT_DH3) ) { // Three-slot packet with data
	    nb_slot = 3; //Because of 3-slot data
	  }
	  if ( (bt->type == BT_DM5) ||  (bt->type == BT_DH5) ) { // Five-slot packet with data
	    nb_slot = 5; //Because of 5-slot data
	  }
	}   
	printf("QOS_STAT_POLLS\tSelected %d\tSlot %d\tTaille %d\ttime %f\n" , index + 1 , nb_slot , ch->size() , s.clock() );
	  
	lc_[index]->recv(p,h);
}





// handle a packet going up the stack
void 
BT_DRRScheduler::FPQ_sendUp (Packet* p, Handler* h)
{
        Scheduler& s = Scheduler::instance();
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt* bt = HDR_BT(p);
	double now = s.clock();
	int size = Payload[bt->type];
	int index = bt->am_addr -1;	
	int nb_slot; int i;

	
	if ( (bt->type == BT_NULL) || (bt->type == BT_POLL) || (bt->type == BT_FHS) || (bt->type == BT_ID) ) { // One-slot packet without data
	  nb_slot = 0; //Because of packet without data
	  FPQ->N_proba[index]  = 0;
	  FPQ->P_geq_one_n[index] = 1;
	  FPQ->P_gre_one_n[index] = 0;
	  FPQ->P_eq_one_n[index] = 1;
	  FPQ->T_0[index] = now - 1E-6 * nb_slot * FPQ->Time_slot ;
	  FPQ->T_n[index] = now - 1E-6 * nb_slot * FPQ->Time_slot ;
	  
	  FPQ->Ns[index] = 0;
	  FPQ->ITLN[index] = 0;

	  FPQ->begin_packet_s[index] = 1;
	  for (i = 0; i < FPQ->nb_slave ; ++i) {
	    ++FPQ->Ns[i]; 
	    ++FPQ->Nm[i]; 
	    ++FPQ->ITLN[i];
	    ++FPQ->ITQE[i]; }
	}
	else { // Packet with data 
	  if ( (bt->type == BT_DM1) ||  (bt->type == BT_DH1) ) { // One-slot packet with data
	    nb_slot = 1; //Because of 1-slot data
	  }
	  if ( (bt->type == BT_DM3) ||  (bt->type == BT_DH3) ) { // Three-slot packet with data
	    nb_slot = 3; //Because of 3-slot data
	  }
	  if ( (bt->type == BT_DM5) ||  (bt->type == BT_DH5) ) { // Five-slot packet with data
	    nb_slot = 5; //Because of 5-slot data
	  }

	  if (FPQ->begin_packet_s[index] == 1 ) { // First segmant of an AP packet
	    FPQ->Ns[index] = 0;
	    
	    // PROBABILITES 
	    double now_b = now - 1E-6 * nb_slot * FPQ->Time_slot;
	    double totaltime = FPQ->T_n[index] - FPQ->T_0[index];
	    double deltat = now_b - FPQ->T_n[index];
	    double lambda_totaltime = totaltime * 1000 / FPQ->FR_s[index];
	    double lambda_deltat = deltat * 1000 / FPQ->FR_s[index];
	    double P_equal_one ;
	    if (FPQ->N_proba[index] == 0)
	      P_equal_one =  lambda_deltat * exp (- lambda_deltat) ;
	    else
	      P_equal_one = exp (- lambda_deltat) * (lambda_deltat  + lambda_totaltime / (FPQ->N_proba[index] + 1 )) * FPQ->P_eq_one_n[index];

	    double P_supequal_one = FPQ->P_eq_one_n[index] * (1 - exp(- lambda_deltat) ) + FPQ->P_gre_one_n[index];
	    
	    ++FPQ->N_proba[index];
	    FPQ->T_n[index] = now_b;
	    FPQ->P_eq_one_n[index] = P_equal_one;
	    FPQ->P_geq_one_n[index] = P_supequal_one;
	    FPQ->P_gre_one_n[index] = P_supequal_one - P_equal_one;
	  }
	   
	  if ( ch->size() == size ) { 
	    // not the last segment of an AP packet -> the next Baseband packet will not be the first segment of an AP packet
	    FPQ->begin_packet_s[index] = 0; 
	  }
	  else { 
	    // last segment of an AP packet -> the next Baseband packet will be the first segment of an AP packet
	    FPQ->begin_packet_s[index] = 1;
	  }

	  for (i = 0; i < FPQ->nb_slave ; ++i) {
	    FPQ->Ns[i] += nb_slot ;
	    FPQ->Nm[i] += nb_slot ;
	    FPQ->ITLN[i] += nb_slot ;
	    FPQ->ITQE[i] += nb_slot ;}
	}

	printf("QOS_STAT_POLLS\tSelected %d\tSlot %d\tTaille %d\ttime %f\n" , index + 1 , nb_slot , ch->size() , s.clock() ); 
	lc_[index]->recv(p,h);
}











		

/* This function not used now, will be required when 
   'traffic' is sent in the reverse direction as well
*/
void
BT_DRRScheduler::schedulePoll(int index)
{
	Scheduler& s = Scheduler::instance(); 
	s.cancel(pollEvent_[index]);
	pollEvent_[index]->num_ = index;
	s.schedule (&ph_, pollEvent_[index], maxPollInterval_[index]);
}

/* create a poll packet */
Packet* 
BT_DRRScheduler::createPOLLpacket (uchar am_addr)
{
	Packet* p = Packet::alloc();
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt* bt = HDR_BT(p);
	bt->type = BT_POLL;
	bt->am_addr = am_addr;
	ch->size() = PollSize;
	return p;
}

/* not used in this version */
void
PollHandler::handle (Event* e)
{
	PollEvent* pe = (PollEvent*)e;	
	uchar am_addr = pe->num_ + 1;
	Packet* pkt = sched_->createPOLLpacket(am_addr);
	sched_->pollQ_->enque(pkt);
	delete pe;
}	






//################## QOS ######################

void
BT_DRRScheduler::QOS_init(char nb_slav_ , int Time_begi_ , double alph_ ) {
  if ( nb_slav_ < 0 ) {
    nb_slav_ = 0; }
  else if ( nb_slav_ > 7 ) {
    nb_slav_ = 7; }

  FPQ->nb_slave = nb_slav_;

  if (Time_begi_ < 0) {
    Time_begi_ = 30000; }

  FPQ->Time_begin = Time_begi_;

  if ( alph_ < 0 ) {
    alph_ = 0; }
  else if ( alph_ > 1 ) {
    alph_ = 1; }

  FPQ->alpha = alph_;

  FPQ->Time_slot = 625;
  for (int i = 0; i < 7 ; ++i ) {
    FPQ->FR_s[i] = 0;
    FPQ->FR_m[i] = 0;
    FPQ->MD_s[i] = 0;
    FPQ->MD_m[i] = 0;
    
    FPQ->N_proba[i] = 0;
    FPQ->T_0[i] = FPQ->Time_begin;
    FPQ->T_n[i] = FPQ->Time_begin;
    FPQ->P_geq_one_n [i] = 1;
    FPQ->P_gre_one_n [i] = 0;
    FPQ->P_eq_one_n [i] = 1;
    FPQ->begin_packet_s[i] = 1;
    FPQ->begin_packet_m[i] = 1;

    FPQ->Pdata_s[i] = 1;
    FPQ->Pdata_m[i] = 1;
    FPQ->Pdata[i] = 1;
   
    FPQ->Ns[i] = 1;
    FPQ->Nm[i] = 1;
    FPQ->N_sm[i]= 1;
 
    FPQ->ITLN[i] = 0;
    FPQ->ITQE[i] = 0;

  }
}


















